import os
import sys
import shutil

import winshell
from win32com.client import Dispatch

unrequired_files = ("install.bat", "install_copy_files.py",
                    "mc3.exe", "miniconda_install.bat", ".git")


def install():

    print("Instalando el Sistema de Predespacho Regional v1.0 beta")

    # Crear una carpeta en donde se copien e instalen todos los archivos
    idir = os.path.join(os.environ["LOCALAPPDATA"], "Merelec", "spr")

    if os.path.exists(idir):
        # Copiamos todos las carpetas y archivos al directorio de instalacion

        print("Copiando archivos del sistema")
        shutil.copytree(os.curdir, idir,
                        ignore=shutil.ignore_patterns(
                            "install.bat", "install_copy_files.py", "mc3.exe", "miniconda_install.bat", ".git"),
                        dirs_exist_ok=True)

    # creates shortcut
    desktop = winshell.desktop()

    path = os.path.join(desktop, "Predespacho Regional.lnk")
    target = os.path.join(
        os.environ["LOCALAPPDATA"], "Merelec", "spr", "run.bat")
    wDir = desktop
    icon = os.path.join(os.environ["LOCALAPPDATA"],
                        "Merelec", "spr", "app.ico")
    shell = Dispatch('WScript.Shell')
    shortcut = shell.CreateShortCut(path)
    shortcut.Targetpath = target
    shortcut.WorkingDirectory = wDir
    shortcut.IconLocation = icon
    shortcut.save()


if __name__ == "__main__":
    install()
